import { ISDL, DatabaseType, Renderer } from 'prisma-datamodel';
import { IntrospectionResult } from '../../common/introspectionResult';
/**
 * Simple wrapper class for an introspection result to keep interface
 * compatibility with relational connectors.
 */
export declare class DocumentIntrospectionResult extends IntrospectionResult {
    protected model: ISDL;
    constructor(model: ISDL, databaseType: DatabaseType, renderer?: Renderer);
    /**
     * @deprecated This returns an unnormalized datamodel and might get removed in the near future.
     */
    getDatamodel(): ISDL;
}
